/**
 *
 * $Id: TextIO.c,v 1.4 1996/04/22 22:56:01 miers Exp $
 *
 * Copyright (C) 1995 Free Software Foundation, Inc.
 *
 * This file is part of the GNU LessTif Library.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 **/

 static char rcsid[] = "$Id: TextIO.c,v 1.4 1996/04/22 22:56:01 miers Exp $";

#include <LTconfig.h>
#include <Xm/XmP.h>
#include <Xm/TextP.h>
#include <stdio.h>
#ifdef HAVE_STRING_H
#include <string.h>
#define ANSI_STRING
#else
#include <strings.h>
#endif
#include <stdlib.h>

/*
 * MLM: FIXME -- without these, misc/test1.c won't compile.  Perhaps these
 * should be installed on the subparts?
 */
char _XmTextIn_XmTextEventBindings1[] =
    ":m <Key>osfPrimaryPaste:   cut-primary() \n\
     :a <Key>osfPrimaryPaste:   cut-primary() \n\
     :<Key>osfPrimaryPaste:     copy-primary() \n\
     :m <Key>osfCut:            cut-primary() \n\
     :a <Key>osfCut:            cut-primary() \n\
     :<Key>osfCut:              cut-clipboard() \n\
     :<Key>osfPaste:            paste-clipboard() \n\
     :m <Key>osfCopy:           copy-primary() \n\
     :a <Key>osfCopy:           copy-primary() \n\
     :<Key>osfCopy:             copy-clipboard() \n\
     s c <Key>osfBeginLine:     beginning-of-file(extend) \n\
     :c <Key>osfBeginLine:      beginning-of-file() \n\
     s <Key>osfBeginLine:       beginning-of-line(extend) \n\
     :<Key>osfBeginLine:        beginning-of-line() \n\
     s c <Key>osfEndLine:       end-of-file(extend) \n\
     :c <Key>osfEndLine:        end-of-file() \n\
     s <Key>osfEndLine:         end-of-line(extend) \n\
     :<Key>osfEndLine:          end-of-line() \n\
     s <Key>osfPageLeft:        page-left(extend) \n\
     :<Key>osfPageLeft:         page-left() \n\
     s c <Key>osfPageUp:        page-left(extend) \n\
     :c <Key>osfPageUp:         page-left() \n\
     s <Key>osfPageUp:          previous-page(extend) \n\
     :<Key>osfPageUp:           previous-page() \n\
     s <Key>osfPageRight:       page-right(extend) \n\
     :<Key>osfPageRight:        page-right() \n\
     s c <Key>osfPageDown:      page-right(extend) \n\
     :c <Key>osfPageDown:       page-right() \n\
     s <Key>osfPageDown:        next-page(extend) \n\
     :<Key>osfPageDown:         next-page() \n\
     :<Key>osfClear:            clear-selection() \n\
     :<Key>osfBackSpace:        delete-previous-character() \n\
     s m <Key>osfDelete:        cut-primary() \n\
     s a <Key>osfDelete:        cut-primary() \n\
     s <Key>osfDelete:          cut-clipboard() \n\
     :c <Key>osfDelete:         delete-to-end-of-line() \n\
     :<Key>osfDelete:           delete-next-character()";


char _XmTextIn_XmTextEventBindings2[] =
    ":c m <Key>osfInsert:       copy-primary() \n\
     :c a <Key>osfInsert:       copy-primary() \n\
     s <Key>osfInsert:          paste-clipboard() \n\
     :c <Key>osfInsert:         copy-clipboard() \n\
     :s <Key>osfSelect:         key-select() \n\
     :<Key>osfSelect:           set-anchor() \n\
     :<Key>osfActivate:         activate() \n\
     :<Key>osfAddMode:          toggle-add-mode() \n\
     :<Key>osfHelp:             Help() \n\
     :<Key>osfCancel:           process-cancel() \n\
     s c <Key>osfLeft:          backward-word(extend) \n\
     :c <Key>osfLeft:           backward-word() \n\
     s <Key>osfLeft:            key-select(left) \n\
     :<Key>osfLeft:             backward-character() \n\
     s c <Key>osfRight:         forward-word(extend) \n\
     :c <Key>osfRight:          forward-word() \n\
     s <Key>osfRight:           key-select(right) \n\
     :<Key>osfRight:            forward-character() \n\
     s c <Key>osfUp:            backward-paragraph(extend) \n\
     :c <Key>osfUp:             backward-paragraph() \n\
     s <Key>osfUp:              process-shift-up() \n\
     :<Key>osfUp:               process-up() \n\
     s c <Key>osfDown:          forward-paragraph(extend) \n\
     :c <Key>osfDown:           forward-paragraph() \n\
     s <Key>osfDown:            process-shift-down() \n\
     :<Key>osfDown:             process-down() \n\
     c ~m ~a <Key>slash:        select-all() \n\
     c ~m ~a <Key>backslash:    deselect-all() \n\
     s ~m ~a <Key>Tab:          prev-tab-group() \n\
     c ~m ~a <Key>Tab:          next-tab-group() \n\
     ~m ~a <Key>Tab:            process-tab() \n\
     c ~s ~m ~a <Key>Return:    activate() \n\
     ~c ~s ~m ~a <Key>Return:   process-return() \n\
     c ~s ~m ~a <Key>space:     set-anchor() \n\
     c s ~m ~a <Key>space:      key-select() \n\
     s ~c ~m ~a <Key>space:     self-insert() \n\
     <Key>:                     self-insert()";


char _XmTextIn_XmTextEventBindings3[] =
    "<Unmap>:                    unmap() \n\
     <EnterWindow>:              enter() \n\
     <LeaveWindow>:              leave() \n\
     <FocusIn>:                  focusIn() \n\
     <FocusOut>:                 focusOut() \n\
     ~c s ~m ~a <Btn1Down>:      extend-start() \n\
     c ~s ~m ~a <Btn1Down>:      move-destination() \n\
     ~c ~s ~m ~a <Btn1Down>:     grab-focus() \n\
     ~c ~m ~a <Btn1Motion>:      extend-adjust() \n\
     ~c ~m ~a <Btn1Up>:          extend-end() \n\
     <Btn2Down>:                 process-bdrag() \n\
     m ~a <Btn2Motion>:          secondary-adjust() \n\
     ~m a <Btn2Motion>:          secondary-adjust() \n\
     ~s <Btn2Up>:                copy-to() \n\
     ~c <Btn2Up>:                move-to()";

/*
 * MLM: FIXME -- I don't know if this is a bug in the Solaris/IXI/Motif
 * header file (TransltnsP.h), or if there is a fourth TextIn binding.
 * Check this.
 */
#if 0
char _XmTextIn_XmTextEventBindings3[] =
    "<Unmap>:                        unmap() \n\
     <EnterWindow>:                  enter() \n\
     <LeaveWindow>:                  leave() \n\
     <FocusIn>:                      focusIn() \n\
     <FocusOut>:                     focusOut() \n\
     ~c s ~m ~a <Btn1Down>:          extend-start() \n\
     c ~s ~m ~a <Btn1Down>:          move-destination() \n\
     ~c ~s ~m ~a <Btn1Down>:         grab-focus() \n\
     ~c ~m ~a <Btn1Motion>:          extend-adjust() \n\
     ~c ~m ~a <Btn1Up>:              extend-end() \n\
     <Btn2Down>:                     process-bdrag() \n\
     m ~a <Btn2Motion>:              secondary-adjust() \n\
     ~m a <Btn2Motion>:              secondary-adjust() \n\
     ~s <Btn2Up>:                    copy-to() \n\
     ~c <Btn2Up>:                    move-to()";
#endif

XmTextSource
_XmStringSourceCreate(char *value, Boolean is_wchar)
{
    return NULL;
}

void
_XmStringSourceDestroy(XmTextSource source)
{
}

char *
_XmStringSourceGetValue(XmTextSource source, Boolean want_wchar)
{
    return NULL;
}

void
_XmStringSourceSetValue(XmTextWidget widget, char *value)
{
}

Boolean
_XmStringSourceHasSelection(XmTextSource source)
{
    return False;
}

Boolean
_XmStringSourceGetEditable(XmTextSource source)
{
    return False;
}

void
_XmStringSourceSetEditable(XmTextSource source, Boolean editable)
{
}

int
_XmStringSourceGetMaxLength(XmTextSource source)
{
    return 0;
}

void
_XmStringSourceSetMaxLength(XmTextSource source, int max)
{
}

char *
_XmStringSourceGetString(XmTextWidget tw,
			 XmTextPosition from,
			 XmTextPosition to,
			 Boolean want_wchar)
{
    return NULL;
}

Boolean
_XmTextFindStringBackwards(Widget w,
			   XmTextPosition start,
			   char *search_string,
			   XmTextPosition *position)
{
    return False;
}

Boolean
_XmTextFindStringForwards(Widget w,
			  XmTextPosition start,
			  char *search_string,
			  XmTextPosition *position)
{
    return False;
}

Boolean
_XmStringSourceFindString(Widget w,
			  XmTextPosition start,
			  char *string,
			  XmTextPosition *position)
{
    return False;
}

void
_XmStringSourceSetGappedBuffer(XmSourceData data, XmTextPosition position)
{
}

Boolean
_XmTextModifyVerify(XmTextWidget initiator,
		    XEvent *event,
		    XmTextPosition *start,
		    XmTextPosition *end,
		    XmTextPosition *cursorPos,
		    XmTextBlock block,
		    XmTextBlock newblock,
		    Boolean *freeBlock)
{
    return False;
}


void
_XmTextDrawDestination(XmTextWidget widget)
{
}

void
_XmTextClearDestination(XmTextWidget widget, Boolean ignore_sens)
{
}

void
_XmTextDestinationVisible(Widget w, Boolean turn_on)
{
}

void
_XmTextChangeBlinkBehavior(XmTextWidget widget, Boolean newvalue)
{
}

void
_XmTextOutputCreate(Widget wid, ArgList args, Cardinal num_args)
{
}

void
_XmTextAdjustGC(XmTextWidget tw)
{
}

Boolean
_XmTextShouldWordWrap(XmTextWidget widget)
{
    return False;
}

Boolean
_XmTextScrollable(XmTextWidget widget)
{
    return False;
}

void
_XmTextOutputGetSecResData(XmSecondaryResourceData *secResDataRtn)
{
}

int
_XmTextGetNumberLines(XmTextWidget widget)
{
    return 0;
}

Boolean
_XmTextGetDisplayRect(Widget w, XRectangle *display_rect)
{
    return False;
}

void
_XmTextMarginsProc(Widget w, XmBaselineMargins *margins_rec)
{
}

void
_XmTextChangeHOffset(XmTextWidget widget, int length)
{
}

void
_XmTextToggleCursorGC(Widget widget)
{
}

void
_XmTextFreeContextData(Widget w, XtPointer clientData, XtPointer callData)
{
}

void
_XmTextResetClipOrigin(XmTextWidget tw,
		       XmTextPosition position,
		       Boolean clip_mask_reset) 
{
}

XmTextPosition
_XmTextFindLineEnd(XmTextWidget widget,
		   XmTextPosition position,
		   LineTableExtra *extra)
{
    return 0;
}

void
_XmTextMovingCursorPosition(XmTextWidget tw, XmTextPosition position)
{
}

Boolean
_XmTextGetBaselines(Widget widget, Dimension **baselines, int *line_count)
{
    return False;
}


Widget
_XmTextGetDropReciever(Widget w)
{
    return NULL;
}

Boolean
_XmTextHasDestination(Widget w)
{
    return False;
}

void
_XmTextInputGetSecResData(XmSecondaryResourceData *secResDataRtn)
{
}

XmTextPosition
_XmTextGetAnchor(XmTextWidget tw)
{
    return 0;
}

void
_XmTextInputCreate(Widget wid, ArgList args, Cardinal num_args)
{
}

Boolean
_XmTextSetDestinationSelection(Widget w,
			       XmTextPosition position,
			       Boolean disown,
			       Time set_time)
{
    return False;
}

Boolean
_XmTextSetSel2(XmTextWidget tw,
	       XmTextPosition left,
	       XmTextPosition right,
	       Time set_time)
{
    return False;
}

Boolean
_XmTextGetSel2(XmTextWidget tw,
	       XmTextPosition *left,
	       XmTextPosition *right)
{
    return False;
}

